/***************************************************************************
                          shape.h  -  description
                             -------------------
    begin                : Thu Oct 2 2003
    copyright            : (C) 2003 by Marek Rychlik
    email                : marek@rychliks.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef ABSTRACTSHAPE_H
#define ABSTRACTSHAPE_H


/**
  *@author Marek Rychlik
  */

  
#include "vec3f.h"
#include "ray.h"
#include "abstractnode.h"
#include "material.h"
#include "hit.h"

class AbstractShape : public AbstractNode {
public: 
  virtual ~AbstractShape();
  virtual ostream& print(ostream& s) const = 0;
  virtual const char* getname() const = 0;
  /** Get normal at a point */
  virtual Vec3f getnormal(const Vec3f& pt) const = 0;
  /** No descriptions */
  virtual Hit* reflect(const Ray & ray) const = 0;
};

#endif
/*
;;; Local Variables: ***
;;; mode:C++ ***
;;; End: ***
*/
