/***************************************************************************
                          main.cpp  -  description
                             -------------------
    begin                : Thu Oct  2 02:31:00 MST 2003
    copyright            : (C) 2003 by Marek Rychlik
    email                : marek@rychliks.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <iostream>
#include <cstdlib>

#include "sphere.h"
#include "plane.h"
#include "pointlight.h"
#include "scene.h"
#include "nullrenderer.h"
#include "debugrenderer.h"
#include "pgmrenderer.h"
#include "ppmrenderer.h"

int main(int argc, char *argv[])
{
  Scene scene;

  //scene.getcamera().setscale(2.0);
  scene.getcamera().setangle_degrees(30);
  scene.getcamera().setlocation(Vec3f(0,0,-8));

  scene.addshape(new Sphere(0.5, 0, 1, 1));
  scene.addshape(new Sphere(0, 0.5, 0, .3));
  scene.addshape(new Sphere(0, -1.5, 1, .8));
  scene.addshape(new Plane(0, 0, -1, -3));

  scene.addpointlight(Color(.5,.7,.2), Vec3f(1, 1, -1));
  scene.addpointlight(Color(.3,.2,.9), Vec3f(-1, 1, -1));
  scene.addpointlight(Color(.9,.2,.1), Vec3f(-1, -1, -1));

  cerr << scene << endl;

  PPMRenderer renderer(512, 512);

  scene.render(renderer);

  renderer.output(cout);

  return EXIT_SUCCESS;
}
