/***************************************************************************
                          material.h  -  description
                             -------------------
    begin                : Sat Oct 4 2003
    copyright            : (C) 2003 by Marek Rychlik
    email                : marek@rychliks.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef MATERIAL_H
#define MATERIAL_H


/**
  *@author Marek Rychlik
  */

#include "vec3f.h"
#include "abstractnode.h"

class Material : public AbstractNode {
public: 
	Material();
	virtual ~Material();
  /** Write property of Vec3f specularReflection. */
  virtual void setspecularReflection( const Vec3f& _newVal);
  /** Read property of Vec3f specularReflection. */
  virtual const Vec3f& getspecularReflection();
  /** Write property of Vec3f transparency. */
  virtual void settransparency( const Vec3f& _newVal);
  /** Read property of Vec3f transparency. */
  virtual const Vec3f& gettransparency();
  /** No descriptions */
  ostream & print(ostream & s) const;
  /** No descriptions */
  const char * getname() const;
public: // Public attributes
  /**  */
  Vec3f specularReflection;
protected: // Protected attributes
  /**  */
  Vec3f transparency;
};

#endif
