/***************************************************************************
                          plane.h  -  description
                             -------------------
    begin                : Thu Oct 2 2003
    copyright            : (C) 2003 by Marek Rychlik
    email                : marek@rychliks.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef PLANE_H
#define PLANE_H


/**
  *@author Marek Rychlik
  */
#include "abstractshape.h"
#include "vec3f.h"
#include "ray.h"

class Plane : public AbstractShape {
public: 
	Plane();
	virtual ~Plane();
  /** Write property of Vec3f normal. */
  virtual void setnormal( const Vec3f& _newVal);
  /** Read property of Vec3f normal. */
  /** Signed distance from the origin. */

  virtual const Vec3f& getnormal() const;
  /** Write property of float distance. */
  virtual void setdistance( const float& _newVal);
  /** Read property of float distance. */
  virtual const float& getdistance();
  /** Bounce a ray off this plane */
  Hit* reflect(const Ray& ray) const;
  /** No descriptions */
  Plane(const Vec3f& normal, const float& distance);
  /** Compute unit normal at a point. */
  Vec3f getnormal(const Vec3f& pt) const;
  /** No descriptions */
  virtual const char* getname() const;
  virtual ostream& print(ostream& s) const;
  /** No descriptions */
   Plane(const Vec3f& normal, float distance);
  /** No descriptions */
   Plane(float x, float y, float z, float _distance);
  
protected:
 
  Vec3f normal;
  float distance;
};

#endif

/*
;;; Local Variables: ***
;;; mode:C++ ***
;;; End: ***
*/

