/***************************************************************************
                          pointlight.cpp  -  description
                             -------------------
    begin                : Thu Oct 2 2003
    copyright            : (C) 2003 by Marek Rychlik
    email                : marek@rychliks.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "pointlight.h"

PointLight::PointLight() : color(1, 1, 1), location(0, 0, -.9) {
}
PointLight::PointLight(const Color& _color, const Vec3f _location) : color(_color), location(_location) {
}
PointLight::~PointLight(){
}
/** Read property of Color color. */
const Color& PointLight::getcolor() const{
	return color;
}
/** Write property of Color color. */
void PointLight::setcolor( const Color& _newVal){
	color = _newVal;
}
/** No descriptions */
ostream & PointLight::print(ostream & s) const{
  return s << "color=" << color;
}
/** No descriptions */
const char * PointLight::getname() const{
  return "PointLight";
}
/** Read property of Vec3f location. */
const Vec3f& PointLight::getlocation() const{
	return location;
}
/** Write property of Vec3f location. */
void PointLight::setlocation( const Vec3f& _newVal){
	location = _newVal;
}
