/***************************************************************************
                          pointlight.h  -  description
                             -------------------
    begin                : Thu Oct 2 2003
    copyright            : (C) 2003 by Marek Rychlik
    email                : marek@rychliks.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef POINTLIGHT_H
#define POINTLIGHT_H

/**
  *@author Marek Rychlik
  */

#include "color.h"
#include "abstractlight.h"
                      
class PointLight : public AbstractLight {
public: 
	PointLight();
	PointLight(const Color& color, const Vec3f location);
	virtual ~PointLight();
  /** Write property of Color color. */
  virtual void setcolor( const Color& _newVal);
  /** Read property of Color color. */
  virtual const Color& getcolor() const;
  /** Write property of Vec3f location. */
  virtual void setlocation( const Vec3f& _newVal);
  /** Read property of Vec3f location. */
  virtual const Vec3f& getlocation() const;
protected: // Protected attributes
  /** No descriptions */
  const char * getname() const;
  /** No descriptions */
  ostream & print(ostream & s) const;
  /**  */
  Color color;
  /**  */
  Vec3f location;
};

#endif
/*
;;; Local Variables: ***
;;; mode:C++ ***
;;; End: ***
*/
