/***************************************************************************
                          ppmrenderer.cpp  -  description
                             -------------------
    begin                : Tue Oct 7 2003
    copyright            : (C) 2003 by Marek Rychlik
    email                : marek@rychliks.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "ppmrenderer.h"
#include <iostream>

using namespace std;

PPMRenderer::PPMRenderer(unsigned _width, unsigned _height) : ArrayRenderer(_width, _height) {
}
PPMRenderer::~PPMRenderer(){
}

/** No descriptions */
ostream& PPMRenderer::output(ostream& s) const{
  s <<  "P3" << endl
    <<  "# Color rendered by miniray" << endl
    << width << " " << height << endl << 255 << endl;
  unsigned offset = 0;
  for(unsigned int row = 0; row < height; row++) {
    for(unsigned int column = 0; column < width; column++) {
      const Color& color = pixmap[offset + column];
      s << color.ir() << " " << color.ig() << " " << color.ib() << endl;
    }
    offset += width;
  }
  return s;
}
