/***************************************************************************
                          ray.cpp  -  description
                             -------------------
    begin                : Thu Oct 2 2003
    copyright            : (C) 2003 by Marek Rychlik
    email                : marek@rychliks.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "ray.h"

Ray::Ray() : origin(0,0,0), direction(0, 0, 1), attenuation(1,1,1), distanceFromSource(0){
}
Ray::~Ray(){
}
/** Read property of Vec3f origin. */
const Vec3f& Ray::getorigin() const {
	return origin;
}
/** Write property of Vec3f origin. */
void Ray::setorigin( const Vec3f& _newVal){
	origin = _newVal;
}
/** Read property of Vec3f direction. */
const Vec3f& Ray::getdirection() const {
	return direction;
}

/** Write property of Vec3f direction. */
void Ray::setdirection( const Vec3f& _newVal){
	direction = _newVal;
	direction.normalize();
}

/** A ray with given origin and direction, and no attenuation yet */
Ray::Ray(const Vec3f _origin, const Vec3f _direction, float _dfs) :
 origin(_origin), direction(_direction), attenuation(1,1,1),
 distanceFromSource(_dfs) {
  direction.normalize();
}
/** Read property of Vec3f attenuation. */
const Vec3f& Ray::getattenuation(){
	return attenuation;
}
/** Write property of Vec3f attenuation. */
void Ray::setattenuation( const Vec3f& _newVal){
	attenuation = _newVal;
}
/** Read property of float distanceFromSource. */
const float& Ray::getdistanceFromSource(){
	return distanceFromSource;
}
/** Write property of float distanceFromSource. */
void Ray::setdistanceFromSource( const float& _newVal){
	distanceFromSource = _newVal;
}
