/***************************************************************************
                          ray.h  -  description
                             -------------------
    begin                : Thu Oct 2 2003
    copyright            : (C) 2003 by Marek Rychlik
    email                : marek@rychliks.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef RAY_H
#define RAY_H


/**
  *@author Marek Rychlik
  */
#include "vec3f.h"

class Ray {
public: 
	Ray();
	virtual ~Ray();
  /** Write property of Vec3f origin. */
  virtual void setorigin( const Vec3f& _newVal);
  /** Read property of Vec3f origin. */
  virtual const Vec3f& getorigin() const;
  /** Write property of Vec3f direction. */
  virtual void setdirection( const Vec3f& _newVal);
  /** Read property of Vec3f direction. */
  virtual const Vec3f& getdirection() const;
  /** No descriptions */
   Ray(const Vec3f _origin, const Vec3f _direction, float _dfs = 0);
  /** Write property of Vec3f attenuation. */
  virtual void setattenuation( const Vec3f& _newVal);
  /** Read property of Vec3f attenuation. */
  virtual const Vec3f& getattenuation();
  /** Write property of float distanceFromSource. */
  virtual void setdistanceFromSource( const float& _newVal);
  /** Read property of float distanceFromSource. */
  virtual const float& getdistanceFromSource();
protected:
  Vec3f origin;
  Vec3f direction;
  Vec3f attenuation;
  /**  */
  float distanceFromSource;
};

#endif

/*
;;; Local Variables: ***
;;; mode:C++ ***
;;; End: ***
*/
