/***************************************************************************
                          scene.h  -  description
                             -------------------
    begin                : Sat Oct 4 2003
    copyright            : (C) 2003 by Marek Rychlik
    email                : marek@rychliks.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SCENE_H
#define SCENE_H
using namespace std;

/**
  *@author Marek Rychlik
  */
#include "shapelist.h"
#include "lightlist.h"
#include "camera.h"
#include "abstractnode.h"
#include "renderer.h"
#include "ray.h"
#include "hit.h"
#include "color.h"

class Scene : public AbstractNode {
public: 
	Scene();
	virtual ~Scene();
  /** Write property of NodeList nodes. */

  /** Read property of NodeList nodes. */

  /** Write property of LightList lights. */
  virtual void setlights( const LightList& _newVal);
  /** Write property of Camera camera. */
  virtual void setcamera( const Camera& _newVal);
  /** Read property of Camera camera. */
  virtual Camera& getcamera();
  /** No descriptions */
  ostream & print(ostream & s) const;
  /** No descriptions */
  const char * getname() const;
  /** No descriptions */
  virtual LightList& getlights();
  /** No descriptions */
  void render(Renderer& r) const;
  /** No descriptions */
  Color trace(const Ray& ray) const;
  /** Write property of ShapeList shapes. */
  virtual void setshapes( const ShapeList& _newVal);
  /** Read property of ShapeList shapes. */
  virtual const ShapeList& getshapes() const;
  /** Read property of ShapeList shapes. */
  virtual ShapeList & getshapes();
  /** No descriptions */
  void addshape(AbstractShape *shape);
  /** No descriptions */
  void addpointlight(const Color& color, const Vec3f& location);
                               
protected: // Protected attributes
  /**  */
  Camera camera;
    /**  */
  LightList lights;
  /**  */
  ShapeList shapes;
  
private:
  Hit* firstHit(const Ray& ray) const;
  Color lambert(const Color& lightColor, const Vec3f& unitTowardsLight, const Vec3f& normalToSurface) const;
};

#endif
