/***************************************************************************
                          shape.cpp  -  description
                             -------------------
    begin                : Thu Oct 2 2003
    copyright            : (C) 2003 by Marek Rychlik
    email                : marek@rychliks.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "shape.h"

Shape::Shape() : rep(0) {
}
Shape::Shape(AbstractShape *_rep) : rep(_rep) {
}
Shape::~Shape(){
}


Hit* Shape::reflect(const Ray & ray) const {
  return rep->reflect(ray);
}

const AbstractShape *Shape::operator->() const
{
  return rep;
}

AbstractShape *Shape::operator->()
{
  return rep;
}

Vec3f Shape::getnormal(const Vec3f& pt) const{
  return rep->getnormal(pt);
}

const char * Shape::getname() const {
  return rep->getname();
}

ostream& Shape::print(ostream& s) const {
  return rep->print(s);
}


