/***************************************************************************
                          shape.h  -  description
                             -------------------
    begin                : Thu Oct 2 2003
    copyright            : (C) 2003 by Marek Rychlik
    email                : marek@rychliks.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SHAPE_H
#define SHAPE_H


/**
  *@author Marek Rychlik
  */

  
#include "vec3f.h"
#include "ray.h"
#include "abstractshape.h"
#include "hit.h"

class Shape : public AbstractShape {
public: 
	Shape();
	Shape(AbstractShape *_rep);
	virtual ~Shape();
  virtual ostream& print(ostream& s) const;
  virtual const char* getname() const;
  /** Get normal at a point */
  virtual Vec3f getnormal(const Vec3f& pt) const;
  /** No descriptions */
  virtual Hit* reflect(const Ray & ray) const;
  /** Delegation en masse */
  const AbstractShape *operator->() const;
  AbstractShape *operator->();
protected: // Protected attributes
  /**  */
  AbstractShape *rep;
};

#endif
/*
;;; Local Variables: ***
;;; mode:C++ ***
;;; End: ***
*/
