/***************************************************************************
                          sphere.h  -  description
                             -------------------
    begin                : Thu Oct 2 2003
    copyright            : (C) 2003 by Marek Rychlik
    email                : marek@rychliks.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SPHERE_H
#define SPHERE_H


/**
  *@author Marek Rychlik
  */

#include "abstractshape.h"
#include "vec3f.h"
#include "ray.h"

class Sphere : public AbstractShape {
public: 
      Sphere();
      virtual ~Sphere();
  /** Write property of Vec3f center. */
  virtual void setcenter( const Vec3f& _newVal);
  /** Read property of Vec3f center. */
  virtual const Vec3f& getcenter();
  /** No descriptions */
  Sphere(float x, float y, float z, float r);
  /** Write property of float radius. */
  virtual void setradius( const float& _newVal);
  /** Read property of float radius. */
  virtual const float& getradius();
  /** Get normal at a point */
  Vec3f getnormal(const Vec3f& pt) const;
  /** No descriptions */
  Hit* reflect(const Ray & ray) const;
  /** No descriptions */
  virtual ostream& print(ostream& s) const;
  /** No descriptions */
  virtual const char * getname() const;
protected:
  Vec3f center;
  float radius;
};

#endif

/*
;;; Local Variables: ***
;;; mode:C++ ***
;;; End: ***
*/
