/***************************************************************************
                          surface.h  -  description
                             -------------------
    begin                : Thu Oct 2 2003
    copyright            : (C) 2003 by Marek Rychlik
    email                : marek@rychliks.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SURFACE_H
#define SURFACE_H


/**
  *@author Marek Rychlik
  */

  
#include "vec3f.h"
#include "ray.h"
#include "abstractnode.h"
#include "material.h"
#include "geometry.h"

class Surface : public AbstractNode {
public: 
	Surface();
	virtual ~Surface();
  /** Compute unit normal at a point. */
  virtual Vec3f getnormal(const Vec3f& pt) const = 0;
  /** No descriptions */
  virtual Ray* reflect(const Ray& ray) const = 0;
  virtual ostream& print(ostream& s) const;
  virtual const char* getname() const;
  /** Write property of Material material. */
  virtual void setmaterial( const Material& _newVal);
  /** Read property of Material material. */
  virtual const Material& getmaterial();
  /** Write property of Geometry geometry. */
  virtual void setgeometry( const Geometry& _newVal);
  /** Read property of Geometry geometry. */
  virtual const Geometry& getgeometry();
public: // Public attributes
public: // Public attributes
  /**  */
  Material material;
protected: // Protected attributes
  /**  */
  Geometry geometry;
};

#endif
/*
;;; Local Variables: ***
;;; mode:C++ ***
;;; End: ***
*/
