/***************************************************************************
                          transform.cpp  -  description
                             -------------------
    begin                : Sat Oct 4 2003
    copyright            : (C) 2003 by Marek Rychlik
    email                : marek@rychliks.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "transform.h"

Transform::Transform() : x(1, 0, 0), y(0, 1, 0), z(0, 0, 1),
translation(0,0,0){
}
Transform::~Transform(){
}
/** Make a transform whose z-axis points in the direction direction
  and whose y axis is in the plane of direction and up
  and whose x axis is chosen to complete to a right-handed coordinate system */
Transform::Transform(const Vec3f& direction, const Vec3f& up)
 : translation(0,0,0){
   z = direction;
   z.normalize();
   y = up - (z * up) * z;
   y.normalize();
   x = y;
   x.cross(z);
   x.normalize();
}
/** Apply this transform to a point */
Vec3f Transform::operator() (const Vec3f& arg) const{
  return arg[0] * x + arg[1] * y + arg[2] * z + translation;
}

