/***************************************************************************
                          vec3f.h  -  description
                             -------------------
    begin                : Thu Oct 2 2003
    copyright            : (C) 2003 by Marek Rychlik
    email                : marek@rychliks.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef VEC3F_H
#define VEC3F_H
using namespace std;

/**
  *@author Marek Rychlik
  */

#include <iostream>

class Vec3f {
 public: 
  Vec3f();
  ~Vec3f();
  /** Constructs a new vector. */
  Vec3f(float x, float y, float z);
  /** No descriptions */
  const float& getx() const;
  /** No descriptions */
  const float& getz() const;
  /** No descriptions */
  const float& gety() const;
  /** No descriptions */
  Vec3f& operator+=(const Vec3f& x);
  Vec3f operator+(const Vec3f& x) const;
  Vec3f& operator-=(const Vec3f& x);
  Vec3f operator-(const Vec3f& x) const;
  Vec3f& operator*=(const float& x);
  Vec3f& operator/=(const float& x);
  float operator*(const Vec3f& x) const;
  friend Vec3f operator*(const float& scalar, const Vec3f& vector);
  /** No descriptions */
  Vec3f& normalize();
  /** No descriptions */
  float length() const;
  /** No descriptions */
  float lengthsq() const;
  friend ostream& operator << (ostream& s, const Vec3f& vector);
  /** No descriptions */
  Vec3f& cross(const Vec3f& x);
  /** No descriptions */
  float operator[](int i) const;
  /** No descriptions */
  Vec3f& min(const Vec3f& _v);

 protected:
  float rep[3] ;
};


#endif

/*
;;; Local Variables: ***
;;; mode:C++ ***
;;; End: ***
*/
